/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ATIVCLIENTE                                              */
/* Tabela : ATIVCLIENTE                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 03/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_ATIVCLIENTE'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_ATIVCLIENTE
GO

CREATE TRIGGER DTULTATU_ATIVCLIENTE
ON ATIVCLIENTE
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'ATIVCLIENTE', 'CDATIVCLI=' + CDATIVCLI+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE ATIVCLIENTE
      SET DTULTATUATCL = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(ATIVCLIENTE.CDATIVCLI,0) = ISNULL(INSERTED.CDATIVCLI,0)) AND
            (ISNULL(ATIVCLIENTE.DSATIVCLI,0) = ISNULL(INSERTED.DSATIVCLI,0));
   END;
END;
GO
