/* Tabela CTRLAIDF: Utiliza Controle AIDF na tela de tipo de operao.*/
/*  Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela CTRLAIDF */
/*  Objetivo: Gerar um log que vai registrar as alteraes na tabela CTRLAIDF("Utiliza Controle AIDF" ),
              utilizando a tabela Geral de Logs de Operaes}*/
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_CRTLAIDF'    AND
                 TYPE   = 'TR' 	            AND
	              U.UID  = O.UID        AND
	              U.NAME = USER)
DROP TRIGGER LOG_CTRLAIDF
GO
CREATE TRIGGER LOG_CTRLAIDF
ON CTRLAIDF
FOR INSERT, UPDATE, DELETE
AS
   DECLARE  @V_USUARIO         VARCHAR(40);
   DECLARE  @V_TIPO            VARCHAR(1);
   DECLARE  @V_ITPESQ          VARCHAR(40);
   DECLARE  @V_DESC            VARCHAR(1000);
   DECLARE  @V_DTOPER          DATETIME;
   DECLARE  @V_DSREMOTEADDR    VARCHAR(15);
   DECLARE  @V_DSREMOTEHOST    VARCHAR(15);
   DECLARE  @V_DSSERVERRDM     VARCHAR(20);
   DECLARE  @V_DSSERVMETHOD    VARCHAR(30);
   DECLARE  @V_DSREMOTEOPER    VARCHAR(12);

/*VARIVEIS DO CURSOR C_CURSORC*/


   DECLARE  @V_ID_COMANDO      VARCHAR(1);

   DECLARE @V_CDEMPRESA_OLD    VARCHAR(2);
   DECLARE @V_CDINSCESTA_OLD   VARCHAR(16);
   DECLARE @V_CDMODDOCFISC_OLD VARCHAR(2);
   DECLARE @V_CDCTRLAIDF_OLD   VARCHAR(10);
   DECLARE @V_DSCTRLAIDF_OLD   VARCHAR(30);
   DECLARE @V_NRNFINICIAL_OLD  VARCHAR(20);
   DECLARE @V_NRNFFINAL_OLD    VARCHAR(20);
   DECLARE @V_QTTALOES_OLD     FLOAT(8);
   DECLARE @V_NRTALOES_OLD     FLOAT(8);
   DECLARE @V_NRUSADOS_OLD     FLOAT(8);
   DECLARE @V_IDBLOQAIDF_OLD   VARCHAR(1);

   DECLARE @V_CDEMPRESA_NEW    VARCHAR(2);
   DECLARE @V_CDINSCESTA_NEW   VARCHAR(16);
   DECLARE @V_CDMODDOCFISC_NEW VARCHAR(2);
   DECLARE @V_CDCTRLAIDF_NEW   VARCHAR(10);
   DECLARE @V_DSCTRLAIDF_NEW   VARCHAR(30);
   DECLARE @V_NRNFINICIAL_NEW  VARCHAR(20);
   DECLARE @V_NRNFFINAL_NEW    VARCHAR(20);
   DECLARE @V_QTTALOES_NEW     FLOAT(8);
   DECLARE @V_NRTALOES_NEW     FLOAT(8);
   DECLARE @V_NRUSADOS_NEW     FLOAT(8);
   DECLARE @V_IDBLOQAIDF_NEW   VARCHAR(1);
BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '';
   EXEC WEBTUNNING @V_DSREMOTEADDR OUTPUT,
                   @V_DSREMOTEHOST OUTPUT,
                   @V_DSSERVERRDM  OUTPUT,
                   @V_DSSERVMETHOD OUTPUT,
                   @V_DSREMOTEOPER OUTPUT;
   EXEC NMUSUARIO  @V_USUARIO OUTPUT;
   SET @V_USUARIO = ISNULL(@V_USUARIO, ' ');



   DECLARE C_CURSORC CURSOR FOR
   SELECT
      'D'
         IDCOMANDO,
         CDEMPRESA,
         CDINSCESTA,
         CDMODDOCFISC,
         CDCTRLAIDF,
         DSCTRLAIDF,
         NRNFINICIAL,
         NRNFFINAL,
         QTTALOES,
         NRTALOES,
         NRUSADOS,
         IDBLOQAIDF,

         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL
   FROM
      DELETED
   WHERE
      CDCTRLAIDF+CDMODDOCFISC+CDINSCESTA+CDEMPRESA NOT IN (SELECT CDCTRLAIDF+CDMODDOCFISC+CDINSCESTA+CDEMPRESA FROM INSERTED)
   UNION ALL

   SELECT
      'U'   IDCOMANDO,
          DELETED.CDEMPRESA,
          DELETED.CDINSCESTA,
          DELETED.CDMODDOCFISC,
          DELETED.CDCTRLAIDF,
          DELETED.DSCTRLAIDF,
          DELETED.NRNFINICIAL,
          DELETED.NRNFFINAL,
          DELETED.QTTALOES,
          DELETED.NRTALOES,
          DELETED.NRUSADOS,
          DELETED.IDBLOQAIDF,

          INSERTED.CDEMPRESA,
          INSERTED.CDINSCESTA,
          INSERTED.CDMODDOCFISC,
          INSERTED.CDCTRLAIDF,
          INSERTED.DSCTRLAIDF,
          INSERTED.NRNFINICIAL,
          INSERTED.NRNFFINAL,
          INSERTED.QTTALOES,
          INSERTED.NRTALOES,
          INSERTED.NRUSADOS,
          INSERTED.IDBLOQAIDF
   FROM
      INSERTED,
      DELETED
   WHERE
      INSERTED.CDCTRLAIDF  = DELETED.CDCTRLAIDF      AND
      INSERTED.CDMODDOCFISC  = DELETED.CDMODDOCFISC  AND
      INSERTED.CDINSCESTA  = DELETED.CDINSCESTA      AND
      INSERTED.CDEMPRESA  = DELETED.CDEMPRESA

   UNION ALL

   SELECT
      'I' IDCOMANDO,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,

         CDEMPRESA,
         CDINSCESTA,
         CDMODDOCFISC,
         CDCTRLAIDF,
         DSCTRLAIDF,
         NRNFINICIAL,
         NRNFFINAL,
         QTTALOES,
         NRTALOES,
         NRUSADOS,
         IDBLOQAIDF
   FROM
      INSERTED
   WHERE
      CDCTRLAIDF+CDMODDOCFISC+CDINSCESTA+CDEMPRESA NOT IN (SELECT CDCTRLAIDF+CDMODDOCFISC+CDINSCESTA+CDEMPRESA FROM DELETED);

      OPEN C_CURSORC;
      FETCH NEXT FROM C_CURSORC INTO @V_ID_COMANDO,
                                     @V_CDEMPRESA_OLD,
                                     @V_CDINSCESTA_OLD,
                                     @V_CDMODDOCFISC_OLD,
                                     @V_CDCTRLAIDF_OLD,
                                     @V_DSCTRLAIDF_OLD,
                                     @V_NRNFINICIAL_OLD,
                                     @V_NRNFFINAL_OLD,
                                     @V_QTTALOES_OLD,
                                     @V_NRTALOES_OLD,
                                     @V_NRUSADOS_OLD,
                                     @V_IDBLOQAIDF_OLD,

                                     @V_CDEMPRESA_NEW,
                                     @V_CDINSCESTA_NEW,
                                     @V_CDMODDOCFISC_NEW,
                                     @V_CDCTRLAIDF_NEW,
                                     @V_DSCTRLAIDF_NEW,
                                     @V_NRNFINICIAL_NEW,
                                     @V_NRNFFINAL_NEW,
                                     @V_QTTALOES_NEW,
                                     @V_NRTALOES_NEW,
                                     @V_NRUSADOS_NEW,
                                     @V_IDBLOQAIDF_NEW;
   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF @V_ID_COMANDO = 'D' BEGIN
         IF @V_CDEMPRESA_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'CdEmpresa=' + @V_CDEMPRESA_OLD;
         END;

         IF @V_CDINSCESTA_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'CdInsEst=' + @V_CDINSCESTA_OLD;
         END;

         IF @V_CDMODDOCFISC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'CdModFisc=' + @V_CDMODDOCFISC_OLD;
         END;

         IF @V_CDCTRLAIDF_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'CdCtrlAidf=' + @V_CDCTRLAIDF_OLD;
         END;

         IF @V_DSCTRLAIDF_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'DsCtrlAidf=' + @V_DSCTRLAIDF_OLD;
         END;

         IF @V_NRNFINICIAL_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'NrNfInicial=' + @V_NRNFINICIAL_OLD;
         END;

         IF @V_NRNFFINAL_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'NrNfFinal=' + @V_NRNFFINAL_OLD;
         END;

         IF @V_QTTALOES_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'QuantTaloes=' + @V_QTTALOES_OLD;
         END;

         IF @V_NRTALOES_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'NrTaloes=' + @V_NRTALOES_OLD;
         END;

         IF @V_NRUSADOS_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Nrusados=' + @V_NRUSADOS_OLD;
         END;

         IF @V_IDBLOQAIDF_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'IdBloqAidf=' + @V_IDBLOQAIDF_OLD;
         END;

         SET @V_TIPO   = '3';
         SET @V_ITPESQ = @V_CDCTRLAIDF_OLD +@V_CDMODDOCFISC_OLD +@V_CDINSCESTA_OLD +@V_CDEMPRESA_OLD;
      END
      ELSE BEGIN
         IF @V_ID_COMANDO= 'U' /*UPDATING*/                                         BEGIN
            IF (ISNULL(@V_CDEMPRESA_OLD,'!') <> ISNULL(@V_CDEMPRESA_NEW,'!'))       OR
               (ISNULL(@V_CDINSCESTA_OLD,'!') <> ISNULL(@V_CDINSCESTA_NEW,'!'))     OR
               (ISNULL(@V_CDMODDOCFISC_OLD,'!') <> ISNULL(@V_CDMODDOCFISC_NEW,'!')) OR
               (ISNULL(@V_CDCTRLAIDF_OLD,'!') <> ISNULL(@V_CDCTRLAIDF_NEW,'!'))     OR
               (ISNULL(@V_DSCTRLAIDF_OLD,'!') <> ISNULL(@V_DSCTRLAIDF_NEW,'!'))     OR
               (ISNULL(@V_NRNFINICIAL_OLD,'!') <> ISNULL(@V_NRNFINICIAL_NEW,'!'))   OR
               (ISNULL(@V_NRNFFINAL_OLD,'!') <> ISNULL(@V_NRNFFINAL_NEW,'!'))       OR
               (ISNULL(@V_QTTALOES_OLD,    -1) <> ISNULL(@V_QTTALOES_NEW, -1))      OR
               (ISNULL(@V_NRTALOES_OLD,    -1) <> ISNULL(@V_NRTALOES_NEW, -1))      OR
               (ISNULL(@V_NRUSADOS_OLD,    -1) <> ISNULL(@V_NRUSADOS_NEW, -1))      OR
               (ISNULL(@V_IDBLOQAIDF_OLD,'!') <> ISNULL(@V_IDBLOQAIDF_NEW,'!'))     BEGIN
               SET @V_TIPO   = '2';
               SET @V_ITPESQ = @V_CDCTRLAIDF_OLD +@V_CDMODDOCFISC_OLD +@V_CDINSCESTA_OLD +@V_CDEMPRESA_OLD;
            END;
         END
         ELSE BEGIN /*Inserting*/
            SET @V_TIPO   = '1';
            SET @V_ITPESQ = @V_CDCTRLAIDF_NEW +@V_CDMODDOCFISC_NEW +@V_CDINSCESTA_NEW +@V_CDEMPRESA_NEW;
         END;

         IF ISNULL(@V_CDEMPRESA_NEW, '!') <> ISNULL(@V_CDEMPRESA_OLD, '!')         BEGIN
            SET @V_DESC = @V_DESC + ' CdEmpresa=' + @V_CDEMPRESA_NEW;
         END;

         IF ISNULL(@V_CDINSCESTA_NEW, '!') <> ISNULL(@V_CDINSCESTA_OLD, '!')       BEGIN
            SET @V_DESC = @V_DESC + ' CdInsEst=' + @V_CDINSCESTA_NEW;
         END;

         IF ISNULL(@V_CDMODDOCFISC_NEW, '!') <> ISNULL(@V_CDMODDOCFISC_OLD, '!')   BEGIN
            SET @V_DESC = @V_DESC + ' CdModFisc=' + @V_CDMODDOCFISC_NEW;
         END;

         IF ISNULL(@V_CDCTRLAIDF_NEW, '!') <> ISNULL(@V_CDCTRLAIDF_OLD, '!')       BEGIN
            SET @V_DESC = @V_DESC + ' CdCtrlAidf=' + @V_CDCTRLAIDF_NEW;
         END;

         IF ISNULL(@V_DSCTRLAIDF_NEW, '!') <> ISNULL(@V_DSCTRLAIDF_OLD, '!')       BEGIN
            SET @V_DESC = @V_DESC + ' DsCtrlAidf=' + @V_DSCTRLAIDF_NEW;
         END;

         IF ISNULL(@V_NRNFINICIAL_NEW, '!') <> ISNULL(@V_NRNFINICIAL_OLD, '!')     BEGIN
            SET @V_DESC = @V_DESC + ' NrNfInicial=' + @V_NRNFINICIAL_NEW;
         END;

         IF ISNULL(@V_NRNFFINAL_NEW, '!') <> ISNULL(@V_NRNFFINAL_OLD, '!')         BEGIN
            SET @V_DESC = @V_DESC + ' NrNfFinal=' + @V_NRNFFINAL_NEW;
         END;

         IF ISNULL(@V_QTTALOES_NEW, -1) <> ISNULL(@V_QTTALOES_OLD, -1)             BEGIN
            SET @V_DESC = @V_DESC + ' QuantTaloes=' + CONVERT(VARCHAR, @V_QTTALOES_NEW);
         END;

         IF ISNULL(@V_NRTALOES_NEW, -1) <> ISNULL(@V_NRTALOES_OLD, -1)             BEGIN
            SET @V_DESC = @V_DESC + ' NrTaloes=' + CONVERT(VARCHAR, @V_NRTALOES_NEW);
         END;

         IF ISNULL(@V_NRUSADOS_NEW, -1) <> ISNULL(@V_NRUSADOS_OLD, -1)             BEGIN
            SET @V_DESC = @V_DESC + ' NrUsados=' + CONVERT(VARCHAR, @V_NRUSADOS_NEW);
         END;

         IF ISNULL(@V_IDBLOQAIDF_NEW, '!') <> ISNULL(@V_IDBLOQAIDF_OLD, '!')       BEGIN
            SET @V_DESC = @V_DESC + ' IdBloqAidf=' + @V_IDBLOQAIDF_NEW;
         END;
      END;

      IF @V_TIPO <> '0' BEGIN
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();
               INSERT INTO LOGOPERA
                   (NMTABELA,      DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                    DSRDMUSUOPER,    DSENDUSUOPER,    DSNMUSUOPER,    DSMETUSUOPER,    CDORESPOPER)
               VALUES
                   ('CTRLAIDF',   @V_DTOPER,       @V_USUARIO,     @V_TIPO,         @V_ITPESQ,       SUBSTRING(@V_DESC,1,300) ,
                   @V_DSREMOTEADDR, @V_DSREMOTEHOST, @V_DSSERVERRDM, @V_DSSERVMETHOD, @V_DSREMOTEOPER);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSORC INTO
                                @V_ID_COMANDO,
                                @V_CDEMPRESA_OLD,
                                @V_CDINSCESTA_OLD,
                                @V_CDMODDOCFISC_OLD,
                                @V_CDCTRLAIDF_OLD,
                                @V_DSCTRLAIDF_OLD,
                                @V_NRNFINICIAL_OLD,
                                @V_NRNFFINAL_OLD,
                                @V_QTTALOES_OLD,
                                @V_NRTALOES_OLD,
                                @V_NRUSADOS_OLD,
                                @V_IDBLOQAIDF_OLD,

                                @V_CDEMPRESA_NEW,
                                @V_CDINSCESTA_NEW,
                                @V_CDMODDOCFISC_NEW,
                                @V_CDCTRLAIDF_NEW,
                                @V_DSCTRLAIDF_NEW,
                                @V_NRNFINICIAL_NEW,
                                @V_NRNFFINAL_NEW,
                                @V_QTTALOES_NEW,
                                @V_NRTALOES_NEW,
                                @V_NRUSADOS_NEW,
                                @V_IDBLOQAIDF_NEW;

   END;
   CLOSE      C_CURSORC;
   DEALLOCATE C_CURSORC;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_CRTLAIDF','5.50.xxx';
GO






















